/*
** Copyright (C) 2020 CERN
**
** This software is provided 'as-is', without any express or implied
** warranty.  In no event will the authors be held liable for any damages
** arising from the use of this software.
**
** Permission is granted to anyone to use this software for any purpose,
** including commercial applications, and to alter it and redistribute it
** freely, subject to the following restrictions:
**
** 1. The origin of this software must not be misrepresented; you must not
**    claim that you wrote the original software. If you use this software
**    in a product, an acknowledgment in the product documentation would be
**    appreciated but is not required.
** 2. Altered source versions must be plainly marked as such, and must not be
**    misrepresented as being the original software.
** 3. This notice may not be removed or altered from any source distribution.
**
** Created on: 2021-10-18T18:44:27+02:00
**     Author: Matteo Ferrari <matteof> <matteo.ferrari.1@cern.ch>
**
*/

#ifndef EXCEPTION_HPP_
#define EXCEPTION_HPP_

#include <string>
#include <system_error>

#include <asm-generic/errno-base.h>

namespace ccut {

enum class ErrorCode
{
    Ok = 0,
    NotPermitted = EPERM,      /**< 1 operation not permitted */
    Interrupted = EINTR,       /**< 4 interrupted */
    IO = EIO,                  /**< 5 io error */
    Denied = EACCES,           /**< 13 permission denied */
    Runtime = EFAULT,          /**< 14 runtime error */
    InvalidArguments = EINVAL, /**< 22 invalid argument */
    Overflow = EOVERFLOW,      /**< 75 overflow error */
    Timeout = ETIMEDOUT,       /**< 110 timeout error */
    Canceled = ECANCELED,      /**< 125 operation aborted */
    NotSupported = ENOTSUP,

    InternalError = 1000, /*< internal error */
};

/**
 * Represents an exception generated by CCUT library
 */
class Exception : public std::exception
{
public:
    Exception() = delete;
    explicit Exception(std::error_code ev);
    Exception(std::error_code ev, const std::string &what);

    inline const std::error_code getErrorCode() const noexcept
    {
        return m_errorCode;
    }

    /**
     * Overload of std::exception
     * @return Error message
     */
    const char *what() const noexcept override;

    static const std::string Category;

protected:
    const std::error_code m_errorCode; //!< Error code
    mutable std::string m_what;        //!< Complete error message
};

std::error_code make_error_code(ccut::ErrorCode);

Exception make_errno_exception();

} // namespace ccut

namespace std {

template<>
struct is_error_code_enum<ccut::ErrorCode> : true_type
{};

} /* namespace std */

#endif /* EXCEPTION_HPP_ */
